<template>
  <div class="wrapper-content wrapper-content--fixed">
    <section>
      <div class="container">
        <Search :value="search" @search="search = $event" />
        <div class="error" v-if="error">
          <p>{{ error }}</p>
        </div>
        <button class="btn btnPrimary" @click="getRepository">Search</button>
        <div class="repos__wrapper" v-if="repos">
          <div class="info">
            <div class="avatar">
              <img :src="info.avatar_url" alt="">
            </div>
            <div class="login">
              <p>{{info.login}}</p>
            </div>
          </div>
          <div class="repo-item" v-for="repo in repos" :key="repo.id">
            <div class="repo-info">
              <a class="link" target="_blank" :href="repo.html_url">{{
                repo.name
              }}</a>
              <span>{{ repo.stargazers_count }} ⭐</span>
            </div>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import axios from "axios";
import Search from "@/components/Search.vue";

export default {
  components: {
    Search,
  },
  data() {
    return {
      search: "",
      repos: null,
      info: null,
      error: null,
      api_url: "https://api.github.com/users/",
    };
  },
  computed: {},
  methods: {
    getRepository() {
      const url_info = this.api_url + this.search;
      const url_repos = this.api_url + this.search + "/repos";
      axios
        .get(url_repos)
        .then((response) => {
          this.repos = response.data;
          this.error = null;
        })
        .catch((error) => {
          console.log(error.message);
          this.repos = null;
          this.error = "Not found this user";
        })
        .finally(() => {});
      axios
        .get(url_info)
        .then((response) => {
          this.info = response.data;
          this.error = null;
        })
        .catch((error) => {
          console.log(error.message);
          this.repos = null;
          this.error = "Not found info for this user";
        })
        .finally(() => {});
    },
  },
};
</script>

<style lang="scss" scoped>
.error {
  border: 1px solid darkmagenta;
  color: red;
  padding: 10px;
  text-align: center;
  margin-top: 30px;
}
.container {
  display: flex;
  align-items: center;
  flex-direction: column;
}
button {
  margin-top: 40px;
}
.repos__wrapper {
  width: 600px;
  margin: 30px 0;
}
.repo-info, .info {
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 10px;
  padding: 10px 0;
  border-bottom: 1px solid #dbdbdb;
}
// .repos-item {
//   display: flex;
//   align-items: center;
//   justify-content: space-between;
// }
</style>
